<template>
  <div class="order-card-left-side">
    <div
      class='info'
      :class="[ !selectedSubOrder && '--active' ]"
      @click="setSelectedSubOrder(null)"
    >
      <div class='info__line'>
        <span class='info__number'>{{ order.number }}</span>
        <div class='info__status'>
          <div class="d-f al-i-c">
            Квота
            <i class='icon alert'></i>
          </div>
          <span class="info__status-value">
            контрактован
          </span>
        </div>
      </div>
      <div class='info__line'>
        <span>Себестоимость заказа</span>
        <span class="info__line-value">
          {{ subOrder.contractorUuid ? '' : '~' }}{{ formatNumber(subOrder.contractorUuid ? (subOrder.totalPrice / (1 + 0.2)) / 100 : order.costPrice / 100 )}} ₽
        </span>
      </div>
      <div class='info__line'>
        <span>В том числе НДС</span>
        <span class="info__line-value">
          {{ order.vatValue ? formatNumber(order.vatValue / 100 ) + ' ₽' : '-' }}
        </span>
      </div>
      <div class='info__line'>
        <span>Маржа</span>
        <div>
          <span class="info__line-value" :class="getMarginClass()">
            <template v-if="subOrder.contractorUuid && subOrder.totalPrice">
              {{(((order.totalPrice / (1 + 0.2)) - (subOrder.totalPrice / (1 + 0.2))) / (order.totalPrice / (1 + 0.2)) * 100) | formatNumber({ dot: 1 }) }}%
            </template>
            <template v-else>
              {{ order.marginInPercent }}%
            </template>
          </span>
          <span class="info__line-value" :class="getMarginClass()">
            <template v-if="subOrder.contractorUuid && subOrder.totalPrice">
              {{((order.totalPrice/(1 + 0.2)) - (subOrder.totalPrice / (1 + 0.2))) / 100 | formatNumber }} ₽
            </template>
            <template v-else>
              {{ formatNumber(order.margin / 100) }} ₽
            </template>
          </span>
        </div>
      </div>
      <div class='info__line'>
        <span>Ответственный</span>
        <span class="info__line-value">
          {{ order.logistTitle }}
        </span>
      </div>
    </div>

    <div class='route'>
      <h3 class="route__title">Маршрут</h3>
      <div class='route__points'>
        <template v-if="subOrders && subOrders.length === 1">
          {{ subOrders[0].startAddress }} → {{ subOrders[0].endAddress }}
        </template>
        <template v-else>
          Москва → Самара
        </template>
      </div>
      <p class="route__info">
        Маршрут состоит из 21 рейса. Для каждого рейса необходимо назначить исполнителя
      </p>
      <div class="route__container">
        <div class="dashed"></div>
        <div class='route__group'
             :class="{ active: index === activeClass }"
             v-for="(group, index) in testRoutes"
             :key="index">
          <div class="plus"
               @click="openGroup(index)">
          </div>
          <div v-show="index !== activeClass"
               class="route__group--info">
            <div class="icon-wrapper">
              <i v-if="group[0].icon === 'tractor'" class='icon tractor-semi-trailer-izoterm-b'></i>
              <i v-else-if="group[0].icon === 'van'" class='icon railway-carriage-refrigerator'></i>
            </div>
            <div class='route__group-number'>
                          <span v-if="group[0].icon === 'tractor'">
                             {{group.length}} машин
                          </span>
              <span v-else-if="group[0].icon === 'van'">
                             {{group.length}} вагона
                          </span>
              <span class="route__group-number-desc">{{ group[0].startAddress }} → {{ group[0].endAddress }}</span>
            </div>
          </div>
          <expand-transition>
            <div v-show="index === activeClass" class="route__group--item-group">
              <div class="route__group--item"
                   :class="[ selectedSubOrder === group.uuid && '--active' ]"
                   v-for="(item, key) in group"
                   :key="key">

                <div class="icon-wrapper">
                  <i v-if="item.icon === 'tractor'" class='icon tractor-semi-trailer-izoterm-b'></i>
                  <i v-else-if="item.icon === 'van'" class='icon railway-carriage-refrigerator'></i>
                </div>
                <div class='route__group-number'>
                  {{ item.number }}
                  <span class="route__group-number-desc">{{ item.startAddress }} → {{ item.endAddress }}</span>
                </div>
                <div class='route__status'>
                  <template v-if="item.status === 'NEW'">
                    Поиск...
                  </template>
                  <template v-else-if="item.status === 'BOOKED' || item.status === 'ALLOCATED'">
                    <svg width="11" height="10" viewBox="0 0 11 10" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                      <path fill-rule="evenodd" clip-rule="evenodd"
                            d="M10.6332 0.199103C11.0469 0.51997 11.1219 1.11511 10.8007 1.52839L4.50181 9.63362C4.33179 9.85239 4.07446 9.98587 3.79753 9.99894C3.52061 10.012 3.25182 9.90336 3.06192 9.70157L0.257407 6.72153C-0.101332 6.34034 -0.0828355 5.74079 0.29872 5.38239C0.680276 5.024 1.2804 5.04248 1.63914 5.42367L3.68394 7.59643L9.30266 0.366428C9.62384 -0.0468497 10.2195 -0.121764 10.6332 0.199103Z"
                            fill="#10CF96"/>
                    </svg>
                  </template>
                  <template v-else-if="item.status === 'CONTRACTED'">
                    <svg width="16" height="9" viewBox="0 0 16 9" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                      <path fill-rule="evenodd" clip-rule="evenodd"
                            d="M10.9502 0.189844C11.3611 0.495162 11.4349 1.06063 11.115 1.45286L5.24375 8.65283C5.07472 8.86011 4.81926 8.98656 4.54439 8.99899C4.26953 9.01143 4.00269 8.90861 3.81388 8.71752L0.256942 5.11753C-0.10033 4.75594 -0.0828772 4.18634 0.295925 3.84529C0.674726 3.50425 1.27143 3.52091 1.6287 3.8825L4.43119 6.71891L9.62704 0.34721C9.94689 -0.0450193 10.5393 -0.115474 10.9502 0.189844ZM15.6363 0.189844C16.0472 0.495162 16.121 1.06063 15.8011 1.45286L9.92986 8.65283C9.76083 8.86011 9.50537 8.98656 9.2305 8.99899C8.95564 9.01143 8.6888 8.90861 8.49999 8.71752L7.61076 7.81752C7.25348 7.45593 7.27094 6.88633 7.64974 6.54528C8.02854 6.20424 8.62525 6.2209 8.98252 6.58249L9.1173 6.71891L14.3132 0.34721C14.633 -0.0450193 15.2254 -0.115474 15.6363 0.189844Z"
                            fill="#10CF96"/>
                    </svg>
                  </template>
                </div>
              </div>
            </div>
          </expand-transition>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {mapGetters, mapMutations} from 'vuex'
import {formatNumber} from 'common-components/src/helpers/common'
import expandTransition from 'common-components/src/obComponents/obExpandTransition'

export default {
  name: 'OrderCardMultiLeftSide',
  data() {
    return {
      oldClick: '',
      activeClass: false,
      testRoutes: [
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          }
        ],
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          }
        ],
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          }
        ],
      ]
    }
  },
  components: {
    expandTransition
  },
  computed: {
    ...mapGetters({
      order: 'order/order',
      isClicar: 'order/isClicar',
      subOrders: 'order/subOrders',
      subOrder: 'order/subOrder',
      selectedSubOrder: 'order/selectedSubOrder'
    }),
  },
  methods: {
    ...mapMutations({
      setSelectedSubOrder: 'order/setSelectedSubOrder'
    }),
    openGroup(index) {
      this.oldClick = index
      if(this.oldClick === this.activeClass){
        this.activeClass = ''
      } else{
        this.activeClass = index
      }

    },
    getMarginClass() {
      if (!this.order.totalPrice) return ''
      let className
      if (this.subOrder.executor) {
        className = (this.order.totalPrice - this.subOrder.totalPrice) >= 0 ? '-caribbean-green' : '-light-raspberry-red'
      } else {
        className = this.order.margin >= 0 ? '-caribbean-green' : '-light-raspberry-red'
      }
      return className
    },
    formatNumber
  }
}
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';
  .order-card-left-side {
    position: relative;
    z-index: 20;
    width: 316px;
    flex-shrink: 0;
    box-shadow: 0px 2px 10px rgba($color-blue-navy-blue, 0.15);

    .info {
      width: 316px;
      min-height: 166px;
      padding: 16px 20px 20px;
      background-color: $background-white;
      color: $color-text-base;
      cursor: pointer;
      border-bottom: 1px solid $color-grey-border;

      &__number {
        margin: 0;
        @include font-mixin(20px, 24px, 600, $color-text-base, 0.8px);
      }

      &__status {
        display: flex;
        flex-direction: column;
        align-items: flex-end;
        @include font-mixin(10px, 12px, 400, $color-grey-span, 0.4px);

        &-value {
          @include font-mixin(9px, 16px, 400, $color-grey-label, 0.4px, uppercase);
        }

        .icon {
          color: $color-blue-navy-blue;
          margin-left: 5px;
          font-weight: bold;
        }
      }

      &__line {
        display: flex;
        justify-content: space-between;
        margin-bottom: 5px;

        &:last-child {
          margin-bottom: 0;
        }

        @include font-mixin(12px, 20px, 400, $color-grey-label, 0.4px);

        &:first-child {
          align-items: flex-end;
        }

        &-value {
          margin-left: 20px;
          text-align: right;
          @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
        }

        &-value + .info__line-value {
          margin-left: 20px;
        }

        .--success {
          .info__line-value {
            color: $color-green-light !important;
          }
        }
      }

      &.--active {
        border-color: $color-blue-navy-blue;
        background-color: $color-blue-navy-blue;
        color: white;
        cursor: default;

        .info__line {
          color: $cornflower-craiola;

          .info__line-value {
            color: $components-LeftSide-left_side_info_active_value;
          }
        }

        .info__number {
          color: $components-LeftSide-left_side_info_number;
        }

        .info__status {
          color: $cornflower-craiola;

          .info__status-value, .icon {
            color: $components-LeftSide-left_side_info_status_value_icon;
          }
        }
      }
    }

    .route {
      padding: 20px 16px 28px 20px;
      border-bottom: 1px solid $color-grey-border;
      /*  &__container{
          position: relative;
          .dashed{
            position: absolute;
            left: 10px;
            top: 20px;
            height: calc(100% - 50px);
            width: 1px;
            border-left: 2px dashed $color-grey-border;
          }
        }*/
      &__title {
        margin-bottom: 5px;
        @include font-mixin(16px, 24px, 700, $color-text-base, 0.4px);
      }

      &__info {
        margin-top: 20px;
        font-size: 12px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: #737682;
      }

      &__points {
        @include font-mixin(14px, 20px, 400, $gray-slate, 0.4px);
      }

      &__group {
        min-height: 40px;
        position: relative;
        margin-top: 35px;
        margin-left: 34px;
        cursor: pointer;

        &:before {
          content: '';
          position: absolute;
          height: 100%;
          width: 0;
          border-left: 2px dashed $color-grey-border;
          left: -24px;
          top: 25px;
        }

        &:after {
          content: '';
          position: absolute;
          height: 0;
          width: 15px;
          border-top: 2px dashed $color-grey-border;
          left: -20px;
          top: 6px;
        }

        &:last-child {
          &:before {
            display: none;
          }
        }

        &-number {
          width: 145px;
          display: flex;
          flex-direction: column;
          margin-left: 10px;
          margin-top: -3px;
          padding: 0 6px 5px 6px;
          border-radius: 3px;
          @include font-mixin(16px, 24px, 400, $color-blue-navy-blue, 0.8px);

          &-desc {
            margin-top: 2px;
            @include font-mixin(10px, 12px, 400, $color-grey-span, 0.1px, uppercase);
            font-variant: small-caps;

            & + .route__details-number-desc {
              margin-top: 7px;
            }
          }
        }

        .icon-wrapper {
          width: 54px;
        }

        .icon {
          font-size: 18px;
          color: $cornflower-craiola;
        }

        .plus {
          position: absolute;
          z-index: 3;
          left: -30px;
          cursor: pointer;
          background: #fff;
          top: 0;
          border-radius: 2px;
          width: 14px;
          height: 14px;
          border: 2px solid $color-grey-border;

          &:after {
            content: '';
            position: absolute;
            width: 6px;
            height: 2px;
            top: 4px;
            left: 2px;
            background: $color-blue-navy-blue;
            border-radius: 2px;
          }

          &:before {
            content: '';
            position: absolute;
            height: 6px;
            width: 2px;
            top: 2px;
            left: 4px;
            background: $color-blue-navy-blue;
            border-radius: 2px;
          }
        }

        &--item {
          display: flex;
          margin-bottom: 25px;

          .icon {
            position: relative;

            &:after {
              content: '';
              position: absolute;
              height: 25px;
              top: 28px;
              left: 20px;
              width: 0;
              border-left: 2px dashed $color-grey-border;
            }
          }

          &.--active {
            cursor: default;
            .route__details-number {
              background-color: $color-blue-navy-blue;
              color: $components-LeftSide-left_route_details_active_number;

              &-desc {
                color: $components-LeftSide-left_route_details_active_number_desc;
              }
            }
          }

          &:last-child {
            .icon {
              &:after {
                display: none;
              }
            }
          }
        }

        &--info {
          display: flex;
        }

        &.active {
          .route__group--item {
            display: flex;
          }

          .route__group--info {
            display: none;
            position: absolute;
          }

          .plus {
            &:before {
              display: none;
            }
          }
        }
      }

      &__status {
        flex-grow: 2;
        margin-left: 5px;
        margin-top: 3px;
        text-align: right;
        @include font-mixin(8px, 10px, 400, $color-grey-span, 0.1px, uppercase);
      }
    }
  }
</style>
